﻿using System;
using System.Collections.Generic;
using System.Text;

namespace SystemCF.Diagnostics.SymbolStore
{
	/// <summary>
	/// Holds the public GUIDs for language types to be used with the symbol store. 
	/// </summary>
	public class SymLanguageType
	{
		// Fields
		/// <summary>
		/// Specifies the GUID of the Basic language type to be used with the symbol store.
		/// </summary>
		public static readonly Guid Basic = Guid.Empty;

		/// <summary>
		/// Specifies the GUID of the C language type to be used with the symbol store.
		/// </summary>
		public static readonly Guid C = Guid.Empty;

		/// <summary>
		/// Specifies the GUID of the Cobol language type to be used with the symbol store.
		/// </summary>
		public static readonly Guid Cobol = Guid.Empty;

		/// <summary>
		/// Specifies the GUID of the C++ language type to be used with the symbol store.
		/// </summary>
		public static readonly Guid CPlusPlus = Guid.Empty;

		/// <summary>
		/// Specifies the GUID of the C# language type to be used with the symbol store.
		/// </summary>
		public static readonly Guid CSharp = Guid.Empty;

		/// <summary>
		/// Specifies the GUID of the ILAssembly language type to be used with the symbol store.
		/// </summary>
		public static readonly Guid ILAssembly = Guid.Empty;

		/// <summary>
		/// Specifies the GUID of the Java language type to be used with the symbol store.
		/// </summary>
		public static readonly Guid Java = Guid.Empty;

		/// <summary>
		/// Specifies the GUID of the JScript language type to be used with the symbol store.
		/// </summary>
		public static readonly Guid JScript = Guid.Empty;

		/// <summary>
		/// Specifies the GUID of the Managed Extensions for C++ language type to be used with the symbol store.
		/// </summary>
		public static readonly Guid MCPlusPlus = Guid.Empty;

		/// <summary>
		/// Specifies the GUID of the Pascal language type to be used with the symbol store.
		/// </summary>
		public static readonly Guid Pascal = Guid.Empty;

		/// <summary>
		/// Specifies the GUID of the SMC language type to be used with the symbol store.
		/// </summary>
		public static readonly Guid SMC = Guid.Empty;
	}

}
